/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalyticsConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalyticsConnectorFormAllOf{}

// GoogleAnalyticsConnectorFormAllOf struct for GoogleAnalyticsConnectorFormAllOf
type GoogleAnalyticsConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Google Analytics View ID.
	ViewId *string `json:"viewId,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
	// Data label (eg accountId, propertyId, profileId etc)
	DataLabel []string `json:"dataLabel,omitempty"`
	// Metric
	Metric []string `json:"metric,omitempty"`
	// Dimension
	Dimension []string `json:"dimension,omitempty"`
	// Limit
	Limit *int32 `json:"limit,omitempty"`
	// Filter
	Filter *string `json:"filter,omitempty"`
	// Sort
	Sort []string `json:"sort,omitempty"`
}

// NewGoogleAnalyticsConnectorFormAllOf instantiates a new GoogleAnalyticsConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalyticsConnectorFormAllOf() *GoogleAnalyticsConnectorFormAllOf {
	this := GoogleAnalyticsConnectorFormAllOf{}
	var limit int32 = 1
	this.Limit = &limit
	return &this
}

// NewGoogleAnalyticsConnectorFormAllOfWithDefaults instantiates a new GoogleAnalyticsConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalyticsConnectorFormAllOfWithDefaults() *GoogleAnalyticsConnectorFormAllOf {
	this := GoogleAnalyticsConnectorFormAllOf{}
	var limit int32 = 1
	this.Limit = &limit
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetViewId returns the ViewId field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetViewId() string {
	if o == nil || IsNil(o.ViewId) {
		var ret string
		return ret
	}
	return *o.ViewId
}

// GetViewIdOk returns a tuple with the ViewId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetViewIdOk() (*string, bool) {
	if o == nil || IsNil(o.ViewId) {
		return nil, false
	}
	return o.ViewId, true
}

// HasViewId returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasViewId() bool {
	if o != nil && !IsNil(o.ViewId) {
		return true
	}

	return false
}

// SetViewId gets a reference to the given string and assigns it to the ViewId field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetViewId(v string) {
	o.ViewId = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

// GetDataLabel returns the DataLabel field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDataLabel() []string {
	if o == nil || IsNil(o.DataLabel) {
		var ret []string
		return ret
	}
	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDataLabelOk() ([]string, bool) {
	if o == nil || IsNil(o.DataLabel) {
		return nil, false
	}
	return o.DataLabel, true
}

// HasDataLabel returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasDataLabel() bool {
	if o != nil && !IsNil(o.DataLabel) {
		return true
	}

	return false
}

// SetDataLabel gets a reference to the given []string and assigns it to the DataLabel field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDimension returns the Dimension field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDimension() []string {
	if o == nil || IsNil(o.Dimension) {
		var ret []string
		return ret
	}
	return o.Dimension
}

// GetDimensionOk returns a tuple with the Dimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetDimensionOk() ([]string, bool) {
	if o == nil || IsNil(o.Dimension) {
		return nil, false
	}
	return o.Dimension, true
}

// HasDimension returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasDimension() bool {
	if o != nil && !IsNil(o.Dimension) {
		return true
	}

	return false
}

// SetDimension gets a reference to the given []string and assigns it to the Dimension field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetDimension(v []string) {
	o.Dimension = v
}

// GetLimit returns the Limit field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetLimit() int32 {
	if o == nil || IsNil(o.Limit) {
		var ret int32
		return ret
	}
	return *o.Limit
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.Limit) {
		return nil, false
	}
	return o.Limit, true
}

// HasLimit returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasLimit() bool {
	if o != nil && !IsNil(o.Limit) {
		return true
	}

	return false
}

// SetLimit gets a reference to the given int32 and assigns it to the Limit field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetLimit(v int32) {
	o.Limit = &v
}

// GetFilter returns the Filter field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetFilter() string {
	if o == nil || IsNil(o.Filter) {
		var ret string
		return ret
	}
	return *o.Filter
}

// GetFilterOk returns a tuple with the Filter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetFilterOk() (*string, bool) {
	if o == nil || IsNil(o.Filter) {
		return nil, false
	}
	return o.Filter, true
}

// HasFilter returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasFilter() bool {
	if o != nil && !IsNil(o.Filter) {
		return true
	}

	return false
}

// SetFilter gets a reference to the given string and assigns it to the Filter field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetFilter(v string) {
	o.Filter = &v
}

// GetSort returns the Sort field value if set, zero value otherwise.
func (o *GoogleAnalyticsConnectorFormAllOf) GetSort() []string {
	if o == nil || IsNil(o.Sort) {
		var ret []string
		return ret
	}
	return o.Sort
}

// GetSortOk returns a tuple with the Sort field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) GetSortOk() ([]string, bool) {
	if o == nil || IsNil(o.Sort) {
		return nil, false
	}
	return o.Sort, true
}

// HasSort returns a boolean if a field has been set.
func (o *GoogleAnalyticsConnectorFormAllOf) HasSort() bool {
	if o != nil && !IsNil(o.Sort) {
		return true
	}

	return false
}

// SetSort gets a reference to the given []string and assigns it to the Sort field.
func (o *GoogleAnalyticsConnectorFormAllOf) SetSort(v []string) {
	o.Sort = v
}

func (o GoogleAnalyticsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalyticsConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ViewId) {
		toSerialize["viewId"] = o.ViewId
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.DataLabel) {
		toSerialize["dataLabel"] = o.DataLabel
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.Dimension) {
		toSerialize["dimension"] = o.Dimension
	}
	if !IsNil(o.Limit) {
		toSerialize["limit"] = o.Limit
	}
	if !IsNil(o.Filter) {
		toSerialize["filter"] = o.Filter
	}
	if !IsNil(o.Sort) {
		toSerialize["sort"] = o.Sort
	}
	return toSerialize, nil
}

type NullableGoogleAnalyticsConnectorFormAllOf struct {
	value *GoogleAnalyticsConnectorFormAllOf
	isSet bool
}

func (v NullableGoogleAnalyticsConnectorFormAllOf) Get() *GoogleAnalyticsConnectorFormAllOf {
	return v.value
}

func (v *NullableGoogleAnalyticsConnectorFormAllOf) Set(val *GoogleAnalyticsConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalyticsConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalyticsConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalyticsConnectorFormAllOf(val *GoogleAnalyticsConnectorFormAllOf) *NullableGoogleAnalyticsConnectorFormAllOf {
	return &NullableGoogleAnalyticsConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableGoogleAnalyticsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalyticsConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
